#!/bin/sh
##-----------------------------------------------------------------------------
## /etc/profile.d/bbtune-df.sh - fli4l
## - makeup for df output
##
##        P L E A S E   R E A D   T H E   D O C U M E N T A T I O N ,
##                      S E E   R E A D M E . T X T
##
##        B I T T E  U N B E D I N G T   D I E   D O K U M E N T A T I O N
##              L E S E N ,  S I E H E   R E A D M E . T X T
##
## Creation:     2014-12-01 hb
## Last Update:  2014-12-14 hb
##
## Internel version 0.1.5
##
## Version 0.2.0
##
## Copyright (c) 2014 Helmut Backhaus <helmut.backhaus@gmx.de>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##-----------------------------------------------------------------------------

#set -x

# Set Variables for colecho
# DF Textcolor
if [ -z "$BBTUNE_SHOW_DF_TEXT" ]
then
  dftcolor=x
else
  dftcolor=`/usr/local/bin/bbtune-pickcolor.sh $BBTUNE_SHOW_DF_TEXT`
fi

# DF Textcolor Warn
if [ -z "$BBTUNE_SHOW_DF_WARN_TEXT" ]
then
  dftwcolor=rd
else
  dftwcolor=`/usr/local/bin/bbtune-pickcolor.sh $BBTUNE_SHOW_DF_WARN_TEXT`
fi

# DF Background 
if [ -z "$BBTUNE_SHOW_DF_BG" ]
then
  dfbcolor=x
else
  dfbcolor=`/usr/local/bin/bbtune-pickcolor.sh $BBTUNE_SHOW_DF_BG`
fi

# DF Background Warn
if [ -z "$BBTUNE_SHOW_DF_WARN_BG" ]
then
  dfbwcolor=x
else
  dfbwcolor=`/usr/local/bin/bbtune-pickcolor.sh $BBTUNE_SHOW_DF_WARN_BG`
fi

# DF Mode
if [ -z "$BBTUNE_SHOW_DF_MODE" ]
then
  dfmcolor=normal
else
  dfmcolor=`/usr/local/bin/bbtune-pickcolor.sh $BBTUNE_SHOW_DF_MODE`
fi

# DF Mode Warn
if [ -z "$BBTUNE_SHOW_DF_WARN_MODE" ]
then
  dfmwcolor=br
else
  dfmwcolor=`/usr/local/bin/bbtune-pickcolor.sh $BBTUNE_SHOW_DF_WARN_MODE`
fi

# Collecting data for printing
df -h | awk '{print $1,$2,$3,$4,$5,$6}' | sed -e '1d' > /var/run/df-ag

# Split Data in variables
i=1
while read line
do
  eval fs$i=$(echo $line | cut -d " " -f1)
  eval size$i=$(echo $line | cut -d " " -f2)
  eval used$i=$(echo $line | cut -d " " -f3)
  eval free$i=$(echo $line | cut -d " " -f4)
  eval perc$i=$(echo $line | cut -d " " -f5)
  eval moun$i=$(echo $line | cut -d " " -f6)
  eval rech1=$(echo $line | cut -d " " -f5 | sed 's/.$//')
  eval zperc$i=$(echo $rech1)
  eval pused$i=$(awk "BEGIN {OFMT=\"%.0f\"; print 50/100*$rech1;}")
  eval rech2=$(echo \$pused$i)
  eval puused$i=$(( 50 - $rech2 ))
  i=$(($i+1))
done < /var/run/df-ag

# Make the textbased output
if [ "$BBTUNE_SHOW_DF_DISP" = "t" ] || [ "$BBTUNE_SHOW_DF_DISP" = "b" ] || [ -z "$BBTUNE_SHOW_DF_DISP" ]
then
  ii=1
  colecho "##### Ausgabe von BBTUNE - DF #####" $dftcolor $dfbcolor $dfmcolor
  echo  
  printf "%-12s%14s%10s%10s%5s %s\n" "Filesystem" "Size" "Used" "Available" "Use%" "Mounted on"

  while [ "$ii" -lt "$i" ]
  do
    eval rech1=$(echo \$zperc$ii)  # variable to calculating with
    eval output1=$(echo \$fs$ii)   # variable to get output conform data
    eval output2=$(echo \$size$ii) # variable to get output conform data
    eval output3=$(echo \$used$ii) # variable to get output conform data
    eval output4=$(echo \$free$ii) # variable to get output conform data
    eval output5=$(echo \$perc$ii) # variable to get output conform data
    eval output6=$(echo \$moun$ii) # variable to get output conform data
    # output variable to have all data in one
    output11=$(printf "%-12s%14s%10s%10s%5s %s\n" "${output1}" "${output2}" "${output3}" "${output4}" "${output5}" "${output6}")
    # Hit Warning value? Output
    if [ "$rech1" -le "$1" ]
    then # normal
      colecho "$output11" $dftcolor $dfbcolor $dfmcolor
    else # Warn
      colecho "$output11" $dftwcolor $dfbwcolor $dfmwcolor
    fi
    ii=$(($ii+1))
  done
  
  if [ "$BBTUNE_SHOW_DF_DISP" = "t" ]
  then
    colecho "##### Ende der Ausgabe von BBTUNE - DF #####" $dftcolor $dfbcolor $dfmcolor
  fi
fi

# Make the bar version
if [ "$BBTUNE_SHOW_DF_DISP" = "g" ] || [ "$BBTUNE_SHOW_DF_DISP" = "b" ]
then
  ii=1
  if [ "$BBTUNE_SHOW_DF_DISP" = "b" ]
  then
    echo
  elif [ "$BBTUNE_SHOW_DF_DISP" = "g" ]
  then
    colecho "##### Ausgabe von BBTUNE - DF #####" $dftcolor $dfbcolor $dfmcolor
    echo
  fi
  
  while [ "$ii" -lt "$i" ]
  do
    eval rech1=$(echo \$zperc$ii)   # variable to calculating with
    eval rech2=$(echo \$pused$ii)   # variable to calculating with
    eval rech3=$(echo \$puused$ii)  # variable to calculating with
    eval output1=$(echo \$fs$ii)    # variable to get output conform data
    eval output5=$(echo \$perc$ii)  # variable to get output conform data
    output11=$(for i in $(seq 1 $rech2); do printf "#"; done) # variable to get needed sign
    output12=$(for i in $(seq 1 $rech3); do printf "."; done) # variable to get needed sign
    output13=$(printf "%-10s|%s%s| %s\n" "${output1}" "${output11}" "${output12}" "Used = ${output5}") # output variable to have all data in one
    
    # Hit Warning value? Output
    if [ "$rech1" -le "$1" ]
    then # Normal
      colecho "$output13" $dftcolor $dfbcolor $dfmcolor
    else # Warn
      colecho "$output13" $dftwcolor $dfbwcolor $dfmwcolor
    fi
    ii=$(($ii+1))
  done
  echo
  colecho "##### Ende der Ausgabe von BBTUNE - DF #####" $dftcolor $dfbcolor $dfmcolor
fi
